hdu 2448 Mining Station on the Sea【最短路Floyd+KM 最佳匹配】

Mining Station on the Sea

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3070    Accepted Submission(s): 924

Problem Description

The ocean is a treasure house of resources and the development of human society comes to depend more and more on it. In order to develop and utilize marine resources, it is necessary to build mining stations on the sea. However, due to seabed mineral resources, the radio signal in the sea is often so weak that not all the mining stations can carry out direct communication. However communication is indispensable, every two mining stations must be able to communicate with each other (either directly or through other one or more mining stations). To meet the need of transporting the exploited resources up to the land to get put into use, there build n ports correspondently along the coast and every port can communicate with one or more mining stations directly.

Due to the fact that some mining stations can not communicate with each other directly, for the safety of the navigation for ships, ships are only allowed to sail between mining stations which can communicate with each other directly. 

The mining is arduous and people do this job need proper rest (that is, to allow the ship to return to the port). But what a coincidence! This time, n vessels for mining take their turns to take a rest at the same time. They are scattered in different stations and now they have to go back to the port, in addition, a port can only accommodate one vessel. Now all the vessels will start to return, how to choose their navigation routes to make the total sum of their sailing routes minimal. 

Notice that once the ship entered the port, it will not come out!

 

 

Input

There are several test cases. Every test case begins with four integers in one line, n (1 = <n <= 100), m (n <= m <= 200), k and p. n indicates n vessels and n ports, m indicates m mining stations, k indicates k edges, each edge corresponding to the link between a mining station and another one, p indicates p edges, each edge indicating the link between a port and a mining station. The following line is n integers, each one indicating one station that one vessel belongs to. Then there follows k lines, each line including 3 integers a, b and c, indicating the fact that there exists direct communication between mining stations a and b and the distance between them is c. Finally, there follows another p lines, each line including 3 integers d, e and f, indicating the fact that there exists direct communication between port d and mining station e and the distance between them is f. In addition, mining stations are represented by numbers from 1 to m, and ports 1 to n. Input is terminated by end of file.

 

 

Output

Each test case outputs the minimal total sum of their sailing routes.

 

 

Sample Input

3 5 5 6

1 2 4

1 3 3

1 4 4

1 5 5

2 5 3

2 4 3

1 1 5

1 5 3

2 5 3

2 4 6

3 1 4

3 2 2

 

 

Sample Output

13

 

 

Source

2008 Asia Regional Harbin

 

题目大意:有n条船,n个港口,m个点,k条无向边,p条有向边,

其中第一行输入为n条船停靠在的点,现在这些船需要回到港口,而且每个港口只能挺一条船。

k条无向边,表示两个点之间的距离,

p条有向边,表示港口到某个点的距离。

每个船都需要回到港口,问最小距离花费。


思路:


1、因为总点数并不是很大,所以我们可以使用Floyd跑出亮点间最短路。


2、然后设定a【i】【j】表示第i个船到第j个港口需要花费的最小消耗,那么我们通过Floyd跑出来的结果对应建图。


3、因为我们要求的是最小匹配,那么我们使用一个极大值(03f3f3f3f-a【i】【j】)得到一个新的a【i】【j】,使得原来的较小值变成了较大值,那么此时跑得的最大匹配即最小匹配,那么ans=n*极大值-最大值匹配。


Ac代码:


#include<stdio.h>
#include<string.h>
#include<iostream>
using namespace std;
#define ll __int64
int map[450][450];
int match[450*450];
int a[450][450];
int lx[450*450];
int ly[450*450];
int vx[450*450];
int vy[450*450];
int at[450];
int low;
int n,m,kk,pp;
int find(int u)
{
    vx[u]=1;
    for(int i=1;i<=n;i++)
    {
        if(vy[i]==1)continue;
        int tmp=lx[u]+ly[i]-a[u][i];
        if(tmp==0)
        {
            vy[i]=1;
            if(match[i]==-1||find(match[i]))
            {
                match[i]=u;
                return 1;
            }
        }
        else if(tmp<low)low=tmp;
    }
    return 0;
}
void KM()
{
    memset(match,-1,sizeof(match));
    memset(lx,0,sizeof(lx));
    memset(ly,0,sizeof(ly));
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            int u=at[i];
            a[i][j]=map[u][j+m];
            a[i][j]=0x3f3f3f3f-a[i][j];
            lx[i]=max(lx[i],a[i][j]);
        }
    }
    for(int i=1;i<=n;i++)
    {
        while(1)
        {
            low=0x3f3f3f3f;
            memset(vx,0,sizeof(vx));
            memset(vy,0,sizeof(vy));
            if(find(i))break;
            for(int j=1;j<=n;j++)
            {
                if(vx[j])lx[j]-=low;
            }
            for(int j=1;j<=n;j++)
            {
                if(vy[j])ly[j]+=low;
            }
        }
    }
    ll sum=0;
    for(int i=1;i<=n;i++)
    {
        sum+=a[match[i]][i];
    }
    printf("%I64d\n",(ll)n*(ll)0x3f3f3f3f-sum);
}
int main()
{
    while(~scanf("%d%d%d%d",&n,&m,&kk,&pp))
    {
        memset(map,0x3f3f3f3f,sizeof(map));
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&at[i]);
        }
        for(int i=1;i<=kk;i++)
        {
            int x,y,w;
            scanf("%d%d%d",&x,&y,&w);
            if(w<map[x][y])
            {
                map[x][y]=w;
                map[y][x]=w;
            }
        }
        for(int i=1;i<=pp;i++)
        {
            int x,y,w;
            scanf("%d%d%d",&x,&y,&w);
            if(map[y][x+m]>w)
            {
                map[y][x+m]=w;
            }
        }
        for(int i=1;i<=n+m;i++)
        {
            for(int j=1;j<=n+m;j++)
            {
                for(int k=1;k<=n+m;k++)
                {
                    map[j][k]=min(map[j][i]+map[i][k],map[j][k]);
                }
            }
        }
        KM();
    }
}




评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值